## hugin 2018.0.0+dfsg

=== CMakeLists.txt ===

# require at least cmake 3.1
cmake_minimum_required(VERSION 3.1.0 FATAL_ERROR )

# prevent in-tree building
if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
    message(FATAL_ERROR "In-source builds are not allowed.")
endif()

if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

if(APPLE)
  set(CMAKE_OSX_DEPLOYMENT_TARGET "10.9")
  if (MAC_SELF_CONTAINED_BUNDLE)
      set(CMAKE_LIBRARY_PATH ${CMAKE_SOURCE_DIR}/mac/ExternalPrograms/repository/lib)
      set(CMAKE_INCLUDE_PATH ${CMAKE_SOURCE_DIR}/mac/ExternalPrograms/repository/include ${CMAKE_SOURCE_DIR}/mac/ExternalPrograms/repository/bin)
  endif(MAC_SELF_CONTAINED_BUNDLE)
  # for FindOpenMP
  set(CMAKE_REQUIRED_INCLUDES ${CMAKE_SOURCE_DIR}/mac/ExternalPrograms/repository/include)
endif(APPLE)

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/CMakeModules )

##
## Cleaner Debian Packaging (disable by -DDISABLE_DPKG=ON)
##
OPTION (DISABLE_DPKG "Do not use debian scripts to get package dependences" OFF)


IF(NOT DISABLE_DPKG)
  set(ARCH_TRIPLET)
  if(UNIX)
    FIND_PROGRAM(DPKG_ARCHITECTURE_EXECUTABLE dpkg-architecture)
    if(DPKG_ARCHITECTURE_EXECUTABLE)
      EXECUTE_PROCESS(COMMAND dpkg-architecture -qDEB_HOST_MULTIARCH
        OUTPUT_VARIABLE ARCH_TRIPLET
        ERROR_VARIABLE ERROR_ARCH_TRIPLET
        OUTPUT_STRIP_TRAILING_WHITESPACE)
    endif()
  endif()
  if(ARCH_TRIPLET)
    set(SYSTEM_LIB_DIRS /usr/lib /usr/lib/${ARCH_TRIPLET} /usr/local/lib)
  else()
    set(SYSTEM_LIB_DIRS /usr/lib /usr/local/lib)
  endif()
ENDIF()

include(HuginMacros)
include(CheckIncludeFiles)

##  global setup
project(hugin)

# version
set(V_MAJOR 2018)
set(V_MINOR 0)
set(V_PATCH 0)

#
# Check for mercurial and get current revision
#

IF(EXISTS ${PROJECT_SOURCE_DIR}/.hg)
  FIND_PACKAGE(Hg)
  IF(HG_FOUND)
    EXECUTE_PROCESS(COMMAND ${HG_EXECUTABLE} summary WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}" OUTPUT_VARIABLE _release OUTPUT_STRIP_TRAILING_WHITESPACE)
    foreach(_v_l ${_release})
      if(_v_l MATCHES "^.*: *[^0-9]*\([0-9]+\):\([a-z0-9]+\)")
        set(CPACK_PACKAGE_VERSION_PATCH ${CMAKE_MATCH_1})
        set(HUGIN_WC_REVISION ${CMAKE_MATCH_2})
      endif()
    endforeach()
  ELSE()
    SET(HUGIN_WC_REVISION 0)
  ENDIF()
  SET(HUGIN_PACKAGE_VERSION ${V_MAJOR}.${V_MINOR}.${V_PATCH})
  SET(HUGIN_DEVELOPMENT_VERSION 1)
  FILE(WRITE ${PROJECT_SOURCE_DIR}/rev.txt "${HUGIN_WC_REVISION}")
  MESSAGE("-- Current HG revision is ${HUGIN_WC_REVISION}")
ELSE()
  IF (EXISTS ${PROJECT_SOURCE_DIR}/.svn)
    # comment out the following line to compile an old version from the subversion repository
    MESSAGE(FATAL_ERROR "Hugin subversion repository is not up to date. The development happens now in mercurial repository. Please switch to mercurial. Sorry for the inconsistency")
  ENDIF()

  SET(CPACK_PACKAGE_VERSION_PATCH ${V_PATCH})
  SET(HUGIN_PACKAGE_VERSION ${V_MAJOR}.${V_MINOR}.${V_PATCH})
  SET(HUGIN_WC_REVISION 0)
  FILE(READ "${PROJECT_SOURCE_DIR}/rev.txt" HUGIN_WC_REVISION)
  MESSAGE("-- Current HG revision is ${HUGIN_WC_REVISION}")
  MESSAGE("-- Assuming this is a tarball (release) build for ${HUGIN_PACKAGE_VERSION}")
  SET(HUGIN_DEVELOPMENT_VERSION 0)
ENDIF()

# version to display
IF (HUGIN_DEVELOPMENT_VERSION EQUAL 1)
  set(DISPLAY_VERSION "Pre-Release ${V_MAJOR}.${V_MINOR}.${V_PATCH}.${HUGIN_WC_REVISION}")
ELSE (HUGIN_DEVELOPMENT_VERSION EQUAL 1)
  set(DISPLAY_VERSION "${V_MAJOR}.${V_MINOR}.${V_PATCH}.${HUGIN_WC_REVISION}")
ENDIF (HUGIN_DEVELOPMENT_VERSION EQUAL 1)

# version for internal libraries.
set(HUGIN_LIB_VERSION 0.0)

# set include path for internal libraries before using finding and initializing
# external dependencies. This makes sure that "our" include paths are specified
# before any system includes

include_directories( ${CMAKE_BINARY_DIR}/src )
include_directories( ${CMAKE_SOURCE_DIR}/src/hugin_base )
include_directories( ${CMAKE_SOURCE_DIR}/src/celeste )
include_directories( ${CMAKE_BINARY_DIR}/src/celeste )
include_directories( ${CMAKE_SOURCE_DIR}/src )

# this function is not available on some systems, notably FreeBSD and Windows
include(CheckFunctionExists)
set(CMAKE_REQUIRED_LIBRARIES -lm)
check_function_exists(log1p HAVE_LOG1P)

#
# find dependencies
#
IF (UNIX)
FIND_PACKAGE(PkgConfig)
ENDIF (UNIX)

IF(WIN32)
    set(HUGIN_SHARED "0" CACHE STRING "Build shared internal libraries" )
ELSE(WIN32)
    set(HUGIN_SHARED "1" CACHE STRING "Build shared internal libraries" )
ENDIF(WIN32)

#
# Setup windows search paths for dependencies
#
IF (WIN32)
  ##
  ## The directory that contains the hugin source root is a good
  ## place to look for support packages, so post it in cache.
  ## 
  ## Our FIND_PACKAGE calls modules will search SOURCE_BASE_DIR
  ## after the local standard places  
  ##
  # extract pathname from CMAKE_SOURCE_DIR (note result must be a local var)
  STRING( REGEX REPLACE "(.*)/[^/]+$" "\\1" work "${CMAKE_SOURCE_DIR}" )
  # create the cache entry
  SET( SOURCE_BASE_DIR ${work} CACHE FILEPATH "parent dir of hugin source root" )

  # wxWidgets
  IF(NOT wxWidgets_ROOT_SUFFIX)
    SET( wxWidgets_ROOT_SUFFIX 3.0.0 CACHE STRING "version of wxWidgets." FORCE )
  ENDIF(NOT wxWidgets_ROOT_SUFFIX)
  IF(NOT wxWidgets_ROOT_DIR)
    SET(wxWidgets_ROOT_DIR ${SOURCE_BASE_DIR}/wxWidgets-${wxWidgets_ROOT_SUFFIX})
  ENDIF()
ENDIF(WIN32)

##
## wxWidgets
##
#  This must come before FINDs for tiff, jpeg, png, zlib to enable
#  finding the wxWidgets distributions of those packages (Win32 only).
SET(wxWidgets_USE_LIBS base core aui xrc html xml adv gl net qa)
FIND_PACKAGE(wxWidgets REQUIRED)

# hugin requires wxwidgets 3.0 or above
IF (UNIX)
  EXEC_PROGRAM(sh ARGS "${wxWidgets_CONFIG_EXECUTABLE} --version" OUTPUT_VARIABLE wxWidgets_VERSION)
  STRING(REGEX REPLACE "^([0-9]+\\.[0-9]+)\\..*" "\\1"  wxWidgets_VERSION ${wxWidgets_VERSION})
  IF(wxWidgets_VERSION VERSION_LESS "3.0")
    MESSAGE(FATAL_ERROR "At least wxWidgets 3.0 is required")
  ENDIF()
  # Ubuntu has 2 different devel packages, we need the GUI version
  EXEC_PROGRAM(sh ARGS "${wxWidgets_CONFIG_EXECUTABLE} --query-toolkit" OUTPUT_VARIABLE wxWidgets_TOOLKIT)
  IF(wxWidgets_TOOLKIT STREQUAL "base")
    MESSAGE(FATAL_ERROR "wxWidgets is as non-GUI package configured. Check you wxWidgets installation (maybe wxgtkXX-devel is missing)")
  ENDIF()
ENDIF (UNIX)

##
## Graphics libraries
##
# wxWidgets sub-packages will be used if native ones aren't found

FIND_PACKAGE(TIFF REQUIRED)
INCLUDE_DIRECTORIES(${TIFF_INCLUDE_DIR})
FIND_PACKAGE(JPEG REQUIRED)
INCLUDE_DIRECTORIES(${JPEG_INCLUDE_DIR})
FIND_PACKAGE(PNG REQUIRED)
INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${PNG_INCLUDE_DIR})

IF(WIN32 AND NOT HUGIN_SHARED)
IF(NOT ${WX_jpeg} MATCHES ${JPEG_LIBRARIES_RELEASE})
MESSAGE(FATAL_ERROR "Using different libjpeg and wxjpeg. This does not work with static libs. Use wxjpeg for libjpeg")
ENDIF()
IF(NOT ${WX_zlib} MATCHES ${ZLIB_LIBRARIES_RELEASE})
MESSAGE(FATAL_ERROR "Using different libzlib and wxzlib. This does not work with static libs. Use wxjpeg for libzlib")
ENDIF()
IF(NOT ${WX_png} MATCHES ${PNG_LIBRARIES_RELEASE})
MESSAGE(FATAL_ERROR "Using different libpng and wxpng. This does not work with static libs. Use wxjpeg for libpng")
ENDIF()
IF(NOT ${WX_tiff} MATCHES ${TIFF_LIBRARIES_RELEASE})
MESSAGE(FATAL_ERROR "Using different libtiff and wxtiff. This does not work with static libs. Use wxtiff for libtiff")
ENDIF()

ENDIF()

FIND_PACKAGE(OpenEXR REQUIRED)
include_directories(${OPENEXR_INCLUDE_DIR})

FIND_PACKAGE(VIGRA 1.9.0 REQUIRED)
include_directories(${VIGRA_INCLUDE_DIR})

FIND_PACKAGE(EXIV2 REQUIRED)
INCLUDE_DIRECTORIES(${EXIV2_INCLUDE_DIR})

## OpenGL and GLEW

FIND_PACKAGE(OpenGL REQUIRED)
INCLUDE_DIRECTORIES(${OPENGL_INCLUDE_DIR})
SET(OPENGL_GLEW_LIBRARIES ${OPENGL_LIBRARIES})
IF (APPLE)
  FIND_PACKAGE(GLUT REQUIRED)
  INCLUDE_DIRECTORIES(${GLUT_INCLUDE_DIR})
  SET(OPENGL_GLEW_LIBRARIES ${OPENGL_GLEW_LIBRARIES} ${GLUT_LIBRARIES})
ENDIF()
FIND_PACKAGE(GLEW REQUIRED)
INCLUDE_DIRECTORIES(${GLEW_INCLUDE_DIR})
SET(OPENGL_GLEW_LIBRARIES ${OPENGL_GLEW_LIBRARIES} ${GLEW_LIBRARIES})
IF(NOT HUGIN_SHARED OR NOT WIN32)
  ADD_DEFINITIONS(-DGLEW_STATIC)
ENDIF()

IF(NOT APPLE AND NOT WIN32)
FIND_PACKAGE(X11 REQUIRED)
ENDIF()
##
## Panotools
##

FIND_PACKAGE(PANO13 2.9.19 REQUIRED)

IF(PANO13_FOUND)
  SET(PANO_LIBRARIES ${PANO13_LIBRARIES})
  SET(PANO_INCLUDE_DIR ${PANO13_INCLUDE_DIR})
ELSE(PANO13_FOUND)
  MESSAGE(SEND_ERROR "libpano13 required")
ENDIF(PANO13_FOUND) 
INCLUDE_DIRECTORIES(${PANO_INCLUDE_DIR})

# Check CXX11 compiler
SET(CMAKE_CXX_STANDARD 11)
SET(CMAKE_CXX_STANDARD_REQUIRED ON)
# necessary threads lib
SET(THREADS_PREFER_PTHREAD_FLAG ON)
FIND_PACKAGE(Threads REQUIRED)

IF(WIN32)
  # for Windows Vista support
  ADD_DEFINITIONS(-DPSAPI_VERSION=1)
ENDIF(WIN32)

# check if we have C++17 <filesystem> header
INCLUDE(CheckCXXSourceCompiles)
check_cxx_source_compiles(
  "
    #include <filesystem>
    #include <string>
    
    int main()
    {
      std::tr2::sys::path filepath;
      filepath=std::tr2::sys::absolute(filepath);
      std::string s=filepath.filename().string();
      return 0;    
    };
  "
  HAVE_STD_FILESYSTEM
)

IF(HAVE_STD_FILESYSTEM)
# in this combination we don't need Boost anymore
ELSE()
##
## Boost
##
# I am sick of having to edit the boost rev number in this file.
# Now it is a cache variable you can edit in cmakesetup --TKS
#
IF( NOT Boost_root_suffix )
  SET( Boost_root_suffix _1_54_0 CACHE STRING "suffix of boost root dir." FORCE )
ENDIF( NOT Boost_root_suffix )

IF(WIN32)
  IF(${HUGIN_SHARED})
    SET(Boost_USE_STATIC_LIBS OFF)
    SET(Boost_USE_STATIC_RUNTIME OFF)
    # ADD_DEFINITIONS(-DBOOST_ALL_DYN_LINK)
    # ADD_DEFINITIONS(-D_DLL)
    ADD_DEFINITIONS(-DBOOST_ALL_NO_LIB)
  ELSE(${HUGIN_SHARED})
    SET(Boost_USE_STATIC_LIBS ON)
    SET(Boost_USE_STATIC_RUNTIME ON)
  ENDIF(${HUGIN_SHARED})
  # If BOOST_ROOT was defined in the environment, use it. 
  IF(NOT BOOST_ROOT AND NOT $ENV{BOOST_ROOT} STREQUAL "") 
    SET(BOOST_ROOT $ENV{BOOST_ROOT})
  ENDIF()
  IF(NOT BOOST_ROOT)
    SET(BOOST_ROOT ${SOURCE_BASE_DIR}/boost${Boost_root_suffix})
  ENDIF()
ENDIF(WIN32)

FIND_PACKAGE(Boost 1.47 COMPONENTS filesystem system)

IF (NOT Boost_FOUND)
  IF(WIN32)
    MESSAGE(FATAL_ERROR "Boost not found. Bad BOOST_ROOT? On windows, try editing Boost_root_suffix")
  ELSE()
    MESSAGE(FATAL_ERROR "Boost not found. Maybe wrong version. Hugin requires at least version 1.47")
  ENDIF()
ENDIF (NOT Boost_FOUND)

INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})
ENDIF()

# find enblend-enfuse base path
IF(WIN32)
  FIND_PATH(ENBLEND_DIR bin/enblend.exe enblend.exe
    PATHS 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.2-win64 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.2-win32 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.1.5-win64 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.1.5-win32 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.1.4-win64 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.1.4-win32 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.1.3-win64 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.1.3-win32 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.1.2-win64 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.1.2-win32 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.1.1-win64 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.1.1-win32 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.1.1 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.1 
      ${SOURCE_BASE_DIR}/enblend-enfuse-4.0
      ${SOURCE_BASE_DIR}/enblend-3.1
      ${SOURCE_BASE_DIR}/enblend-enfuse-3.2
      ${SOURCE_BASE_DIR}/enblend.build
      ${SOURCE_BASE_DIR}/enblend
    DOC "Location of enblend"
    NO_DEFAULT_PATH
  )
  IF(NOT ENBLEND_DIR)
    MESSAGE(FATAL_ERROR "enblend-enfuse files not found.")
  ENDIF()
ENDIF()

# littleCMS 2 now
FIND_PACKAGE(LCMS2 REQUIRED)
INCLUDE_DIRECTORIES(${LCMS2_INCLUDE_DIR})
IF(WIN32)
  IF(${HUGIN_SHARED})
    ADD_DEFINITIONS(-DCMS_DLL)
  ENDIF()
ENDIF()

FIND_PACKAGE(FLANN)

IF(NOT FLANN_FOUND)

=== src/hugin1/CMakeLists.txt ===

include_directories( ${CMAKE_SOURCE_DIR}/src/hugin1 )

INCLUDE(${wxWidgets_USE_FILE})

# do we need to define _UNICODE on windows?
IF(WIN32)
  ADD_DEFINITIONS(-D_UNICODE -DUNICODE)
ENDIF(WIN32)

add_subdirectory(base_wx)
add_subdirectory(stitch_project)
add_subdirectory(icpfind)
add_subdirectory(executor)
add_subdirectory(hugin)
add_subdirectory(ptbatcher)
add_subdirectory(calibrate_lens)

=== src/hugin_base/CMakeLists.txt ===

# a list of all files belonging to hugin base library

SET(HUGIN_BASE_SRC
algorithms/nona/NonaFileStitcher.cpp
algorithms/basic/CalculateCPStatistics.cpp
algorithms/basic/CalculateMeanExposure.cpp
algorithms/basic/CalculateOptimalScale.cpp
algorithms/basic/CalculateOptimalROI.cpp
algorithms/basic/RotatePanorama.cpp
algorithms/basic/TranslatePanorama.cpp
algorithms/basic/StraightenPanorama.cpp
algorithms/basic/CalculateOverlap.cpp
algorithms/basic/LayerStacks.cpp
algorithms/nona/CalculateFOV.cpp
algorithms/nona/CenterHorizontally.cpp
algorithms/nona/FitPanorama.cpp
algorithms/nona/ComputeImageROI.cpp
algorithms/optimizer/ImageGraph.cpp
algorithms/optimizer/PhotometricOptimizer.cpp
algorithms/optimizer/PTOptimizer.cpp
algorithms/point_sampler/PointSampler.cpp
algorithms/control_points/CleanCP.cpp
appbase/ProgressDisplay.cpp
huginapp/CachedImageRemapper.cpp
huginapp/ImageCache.cpp
hugin_math/eig_jacobi.cpp
hugin_math/Matrix3.cpp
hugin_math/Vector3.cpp
hugin_utils/alphanum.cpp
hugin_utils/utils.cpp
hugin_utils/platform.cpp
lensdb/LensDB.cpp
lines/FindLines.cpp 
lines/FindN8Lines.cpp
nona/SpaceTransform.cpp
nona/Stitcher1.cpp
nona/Stitcher2.cpp
nona/Stitcher3.cpp
nona/Stitcher4.cpp
nona/Stitcher.cpp
nona/StitcherOptions.cpp
panodata/ControlPoint.cpp
panodata/Lens.cpp
panodata/Mask.cpp
panodata/Panorama.cpp
panodata/PanoramaOptions.cpp
panodata/PanoramaVariable.cpp
panodata/ParseExp.cpp
panodata/PTScriptParsing.cpp
panodata/SrcPanoImage.cpp
panodata/ImageVariableGroup.cpp
panodata/StandardImageVariableGroups.cpp
panodata/Exiv2Helper.cpp
panotools/PanoToolsInterface.cpp
panotools/PanoToolsOptimizerWrapper.cpp
panotools/PanoToolsUtils.cpp
panotools/PanoToolsTransformGPU.cpp
vigra_ext/emor.cpp
vigra_ext/ImageTransformsGPU.cpp
)

SET(HUGIN_BASE_HEADER
hugin_basic.h
algorithms/PanoramaAlgorithm.h
algorithms/StitcherAlgorithm.h
algorithms/basic/CalculateCPStatistics.h
algorithms/basic/CalculateMeanExposure.h
algorithms/basic/CalculateOptimalScale.h
algorithms/basic/CalculateOptimalROI.h
algorithms/basic/RotatePanorama.h
algorithms/basic/TranslatePanorama.h
algorithms/basic/StraightenPanorama.h
algorithms/basic/CalculateOverlap.h
algorithms/basic/LayerStacks.h
algorithms/control_points/CleanCP.h
algorithms/nona/NonaFileStitcher.h
algorithms/nona/CalculateFOV.h
algorithms/nona/CenterHorizontally.h
algorithms/nona/FitPanorama.h
algorithms/nona/ComputeImageROI.h
algorithms/optimizer/ImageGraph.h
algorithms/optimizer/PhotometricOptimizer.h
algorithms/optimizer/PTOptimizer.h
algorithms/point_sampler/PointSampler.h
appbase/DocumentData.h
appbase/ProgressDisplay.h
huginapp/CachedImageRemapper.h
huginapp/ImageCache.h
hugin_math/eig_jacobi.h
hugin_math/hugin_math.h
hugin_math/Matrix3.h
hugin_math/Vector3.h
hugin_utils/alphanum.h
hugin_utils/openmp_lock.h
hugin_utils/platform.h
hugin_utils/stl_utils.h
hugin_utils/utils.h
lensdb/LensDB.h
lines/FindLines.h
lines/FindN8Lines.h
lines/LinesTypes.h
nona/ImageRemapper.h
nona/RemappedPanoImage.h
nona/SpaceTransform.h
nona/Stitcher.h
nona/StitcherOptions.h
panodata/ControlPoint.h
panodata/Exiv2Helper.h
panodata/ImageVariable.h
panodata/ImageVariableGroup.h
panodata/ImageVariableTranslate.h
panodata/image_variables.h
panodata/Lens.h
panodata/Mask.h
panodata/OptimizerSwitches.h
panodata/Panorama.h
panodata/PanoramaData.h
panodata/PanoramaOptions.h
panodata/PanoramaVariable.h
panodata/ParseExp.h
panodata/PTScriptParsing.h
panodata/SrcPanoImage.h
panodata/StandardImageVariableGroups.h
panotools/PanoToolsInterface.h
panotools/PanoToolsOptimizerWrapper.h
panotools/PanoToolsUtils.h
photometric/ResponseTransform.h
vigra_ext/BlendPoisson.h
vigra_ext/Correlation.h
vigra_ext/cms.h
vigra_ext/emor.h
vigra_ext/FileRAII.h
vigra_ext/FitPolynom.h
vigra_ext/FunctorAccessor.h
vigra_ext/HDRUtils.h
vigra_ext/ImageTransforms.h
vigra_ext/ImageTransformsGPU.h
vigra_ext/InterestPoints.h
vigra_ext/Interpolators.h
vigra_ext/lut.h
vigra_ext/openmp_vigra.h
vigra_ext/Pyramid.h
vigra_ext/pyramid2.h
vigra_ext/ransac.h
vigra_ext/ReduceOpenEXR.h
vigra_ext/ROIImage.h
vigra_ext/StitchWatershed.h
vigra_ext/tiffUtils.h
vigra_ext/utils.h
vigra_ext/VignettingCorrection.h
)

IF (${HUGIN_SHARED_LIBS})
  add_library(huginbase SHARED ${HUGIN_BASE_SRC} ${HUGIN_BASE_HEADER})
  target_link_libraries(huginbase ${Boost_LIBRARIES} Threads::Threads ${X11_X11_LIB})
  set_target_properties(huginbase PROPERTIES VERSION ${HUGIN_LIB_VERSION})
  IF(WIN32)
    install(TARGETS huginbase RUNTIME DESTINATION ${BINDIR})
  ELSEIF(${HUGIN_LIBS_PRIVATE_DIR})
    install(TARGETS huginbase LIBRARY DESTINATION ${LIBDIR}/hugin NAMELINK_SKIP)
  ELSE(WIN32)
    install(TARGETS huginbase LIBRARY DESTINATION ${LIBDIR} NAMELINK_SKIP)
  ENDIF(WIN32)
ELSE (${HUGIN_SHARED_LIBS})
  add_library(huginbase STATIC ${HUGIN_BASE_SRC} ${HUGIN_BASE_HEADER})
ENDIF (${HUGIN_SHARED_LIBS})

TARGET_LINK_LIBRARIES(huginbase huginlevmar ${VIGRA_LIBRARIES} 
        ${Boost_LIBRARIES} ${EXIV2_LIBRARIES} ${PANO_LIBRARIES}
        ${TIFF_LIBRARIES} ${LAPACK_LIBRARIES}
        ${OPENGL_GLEW_LIBRARIES} Threads::Threads
        ${SQLITE3_LIBRARIES} ${LCMS2_LIBRARIES})

IF (MINGW)
    # exiv2 needs psapi and ws2_32 when compiling with Mingw
    TARGET_LINK_LIBRARIES(huginbase psapi ws2_32)
ENDIF() 

source_group(Lines REGULAR_EXPRESSION lines/*)
source_group(Vigra_ext REGULAR_EXPRESSION vigra_ext/*)
source_group(Algorithm REGULAR_EXPRESSION algorithm/*)
source_group(Panodata REGULAR_EXPRESSION panodata/*)
source_group(Panotools REGULAR_EXPRESSION panotools/*)
source_group(Nona REGULAR_EXPRESSION nona/*)
source_group(LensDB REGULAR_EXPRESSION lensdb/*)
source_group(Hugin_utils REGULAR_EXPRESSION hugin_utils/*)
source_group(Hugin_math REGULAR_EXPRESSION hugin_math/*)
source_group(AppBase REGULAR_EXPRESSION "(appbase/*|huginapp/*)")

=== src/hugin_script_interface/CMakeLists.txt ===
# This CMakeList.txt is needed to make The Python 
# scripting interface.

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

MESSAGE(STATUS "Python libs version: ${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}.${PYTHON_VERSION_PATCH}")

# access to the swig runtime code in the hpi module is via
# inclusion of a generated header file, swigpyrun.h:

ADD_CUSTOM_COMMAND(OUTPUT swigpyrun.h
  COMMAND "${SWIG_EXECUTABLE}"
  ARGS "-c++" "-python" "-external-runtime"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  COMMENT "Build header file..."
)

SET_SOURCE_FILES_PROPERTIES("${CMAKE_CURRENT_BINARY_DIR}/swigpyrun.h"
  GENERATED)

# this generated header file and a bit of C++ code make up
# the hpi sources. This is the part of hpi/hsi that actually
# gets linked into hugin to provide access to Python and the
# plugin interface, the remaining code (hsi) stands alone as
# a python module and is dynamically loaded.

SET(HUGIN_HPI_SOURCES
  hpi.h
  hpi_classes.h
  hpi.cpp
  hpi_classes.cpp
  "${CMAKE_CURRENT_BINARY_DIR}/swigpyrun.h"
)

# the hpi sources contitute a library:

IF (${HUGIN_SHARED_LIBS})
  add_library(hugin_python_interface SHARED ${HUGIN_HPI_SOURCES})
  set_target_properties(hugin_python_interface PROPERTIES VERSION ${HUGIN_LIB_VERSION})
  IF(WIN32)
    install(TARGETS hugin_python_interface RUNTIME DESTINATION ${BINDIR})
  ELSEIF(${HUGIN_LIBS_PRIVATE_DIR})
    install(TARGETS hugin_python_interface LIBRARY DESTINATION ${LIBDIR}/hugin NAMELINK_SKIP)
  ELSE(WIN32)
    install(TARGETS hugin_python_interface LIBRARY DESTINATION ${LIBDIR} NAMELINK_SKIP)
  ENDIF(WIN32)
ELSE (${HUGIN_SHARED_LIBS})
  add_library(hugin_python_interface STATIC  ${HUGIN_HPI_SOURCES})
ENDIF (${HUGIN_SHARED_LIBS})
TARGET_LINK_LIBRARIES(hugin_python_interface huginbase ${PYTHON_LIBRARIES})

# the next section deals with setting up hsi, the hugin scripting
# interface. This part generates the hsi Python module.

# some hugin headers use a technique for generating accessors
# to image variables which SWIG can't process. These sections
# of code have to be C-preprocessed so that SWIG recognizes the
# declarations they make and wrap them. The preprocessing is
# linited to sections of these headers, as will become clearer
# when you read on.

# first we define a variable for the hugin_base path

SET(HUGIN_BASE_DIR "${PROJECT_SOURCE_DIR}/src/hugin_base")

# to preprocess C/C++ code, we need the
# adequate flags which differ from MSVC to gcc:

IF(MSVC)
  SET(PREPROCESSOR_FLAGS "/EP")
ELSE()
  SET(PREPROCESSOR_FLAGS "-E")
ENDIF()

# we put together the compiler command, the preprocess-only flag
# and the definition of _HSI_IGNORE_SECTION to exclude sections of
# the preprocessed files

SET(HSI_C_PREPROCESS
    ${CMAKE_CXX_COMPILER}
    ${PREPROCESSOR_FLAGS}
    "-D_HSI_IGNORE_SECTION"
)

# this macro sets up the custom command to preprocess ${in}
# into ${out} and allows to specify additional dependencies,
# in this case that will be image_variables.h

MACRO(preprocess in out depends)
ADD_CUSTOM_COMMAND(OUTPUT ${out}
    COMMAND ${HSI_C_PREPROCESS} ${in} > ${out}
    DEPENDS ${in} ${depends}
)
SET_SOURCE_FILES_PROPERTIES(${out} GENERATED)
ENDMACRO(preprocess)

# we C-preprocess the sections from accessor-generating
# headers that SWIG needs to see, ignoring the parts
# where _HSI_IGNORE_SECTION is define. The resulting
# preprocessed code is put into the target tree.

preprocess("${HUGIN_BASE_DIR}/panodata/ImageVariableGroup.h"
           "${CMAKE_CURRENT_BINARY_DIR}/hsi_ImageVariableGroup.h"
           "${HUGIN_BASE_DIR}/panodata/image_variables.h"
)

preprocess("${HUGIN_BASE_DIR}/panodata/Panorama.h"
           "${CMAKE_CURRENT_BINARY_DIR}/hsi_Panorama.h"
           "${HUGIN_BASE_DIR}/panodata/image_variables.h"
)

preprocess("${HUGIN_BASE_DIR}/panodata/PanoramaData.h"
           "${CMAKE_CURRENT_BINARY_DIR}/hsi_PanoramaData.h"
           "${HUGIN_BASE_DIR}/panodata/image_variables.h"
)

preprocess("${HUGIN_BASE_DIR}/panodata/SrcPanoImage.h"
           "${CMAKE_CURRENT_BINARY_DIR}/hsi_SrcPanoImage.h"
           "${HUGIN_BASE_DIR}/panodata/image_variables.h"
)

# we make a variable containing all preprocessed header
# files that are to be wrapped

SET(hsi_preprocessed
  "${CMAKE_CURRENT_BINARY_DIR}/hsi_ImageVariableGroup.h"
  "${CMAKE_CURRENT_BINARY_DIR}/hsi_Panorama.h"
  "${CMAKE_CURRENT_BINARY_DIR}/hsi_PanoramaData.h"
  "${CMAKE_CURRENT_BINARY_DIR}/hsi_SrcPanoImage.h"
)

# and another variable with all unmodified header
# files that are to be wrapped

SET(hsi_wrappees
  "${HUGIN_BASE_DIR}/appbase/DocumentData.h"
  "${HUGIN_BASE_DIR}/panodata/PanoramaData.h"
  "${HUGIN_BASE_DIR}/panodata/ImageVariable.h"
  "${HUGIN_BASE_DIR}/panodata/ImageVariableGroup.h"
  "${HUGIN_BASE_DIR}/panodata/StandardImageVariableGroups.h"
  "${HUGIN_BASE_DIR}/panodata/ImageVariableTranslate.h"
  "${HUGIN_BASE_DIR}/panodata/Lens.h"
  "${HUGIN_BASE_DIR}/panodata/SrcPanoImage.h"
  "${HUGIN_BASE_DIR}/panodata/PanoramaVariable.h"
  "${HUGIN_BASE_DIR}/panodata/ControlPoint.h"
  "${HUGIN_BASE_DIR}/panodata/PanoramaOptions.h"
  "${HUGIN_BASE_DIR}/panodata/PanoramaData.h"
  "${HUGIN_BASE_DIR}/panodata/Panorama.h"
  "${HUGIN_BASE_DIR}/panotools/PanoToolsUtils.h"
  "${HUGIN_BASE_DIR}/panotools/PanoToolsInterface.h"
  "${HUGIN_BASE_DIR}/panotools/PanoToolsOptimizerWrapper.h"
  "${HUGIN_BASE_DIR}/algorithms/PanoramaAlgorithm.h"
  "${HUGIN_BASE_DIR}/algorithms/StitcherAlgorithm.h"
  "${HUGIN_BASE_DIR}/algorithms/basic/CalculateCPStatistics.h"
  "${HUGIN_BASE_DIR}/algorithms/basic/CalculateMeanExposure.h"
  "${HUGIN_BASE_DIR}/algorithms/basic/CalculateOptimalROI.h"
  "${HUGIN_BASE_DIR}/algorithms/basic/CalculateOptimalScale.h"
  "${HUGIN_BASE_DIR}/algorithms/basic/CalculateOverlap.h"
  "${HUGIN_BASE_DIR}/algorithms/basic/RotatePanorama.h"
  "${HUGIN_BASE_DIR}/algorithms/basic/LayerStacks.h"
  "${HUGIN_BASE_DIR}/algorithms/basic/StraightenPanorama.h"
  "${HUGIN_BASE_DIR}/algorithms/basic/TranslatePanorama.h"
  "${HUGIN_BASE_DIR}/algorithms/control_points/CleanCP.h"
  "${HUGIN_BASE_DIR}/algorithms/nona/CalculateFOV.h"
  "${HUGIN_BASE_DIR}/algorithms/nona/CenterHorizontally.h"
  "${HUGIN_BASE_DIR}/algorithms/nona/ComputeImageROI.h"
  "${HUGIN_BASE_DIR}/algorithms/nona/FitPanorama.h"
  "${HUGIN_BASE_DIR}/algorithms/nona/NonaFileStitcher.h"
  "${HUGIN_BASE_DIR}/algorithms/optimizer/PhotometricOptimizer.h"
  "${HUGIN_BASE_DIR}/algorithms/optimizer/PTOptimizer.h"
  "${HUGIN_BASE_DIR}/algorithms/point_sampler/PointSampler.h"
)

# we tell SWIG to also look in the target path

SET(CMAKE_SWIG_FLAGS "-I${CMAKE_CURRENT_BINARY_DIR}")

# now we add the dependencies of the hsi SWIG module
# from all the wrapped files.

SET(SWIG_MODULE_hsi_EXTRA_DEPS
  ${hsi_preprocessed}
  ${hsi_wrappees}
)

# finally, we specify the hsi module itself

SET_SOURCE_FILES_PROPERTIES(hsi.i PROPERTIES CPLUSPLUS ON)
SWIG_ADD_MODULE(hsi python hsi.i)
SWIG_LINK_LIBRARIES(hsi ${PYTHON_LIBRARIES} ${common_libs})

# The remainder defines where the files are installed.
# TODO this section is incomplete - non-windows install is missing

IF(WIN32)
    INSTALL(TARGETS ${SWIG_MODULE_hsi_REAL_NAME} DESTINATION ${BINDIR})
    INSTALL(FILES hpi.py DESTINATION ${BINDIR})
    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/hsi.py DESTINATION ${BINDIR})
ELSE()
    # Linux/MacOS
    # install Python related files into folder depending on used Python version

    EXECUTE_PROCESS( COMMAND ${PYTHON_EXECUTABLE} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))"
                     OUTPUT_VARIABLE pyinstalldir
                     OUTPUT_STRIP_TRAILING_WHITESPACE)

    # replaced by the above EXECUTE_PROCESS command.
    #SET(pynstalldir
    #    ${LIBDIR}/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/dist-packages
    #    )

    MESSAGE("-- Install Python libs into ${pyinstalldir}")

    INSTALL(TARGETS ${SWIG_MODULE_hsi_REAL_NAME}
            LIBRARY DESTINATION ${pyinstalldir}
            NAMELINK_SKIP
            )

    INSTALL(PROGRAMS hpi.py
            DESTINATION ${pyinstalldir}
            )

    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/hsi.py
            DESTINATION ${pyinstalldir}
            )

ENDIF()

ADD_SUBDIRECTORY(plugins)
ADD_SUBDIRECTORY(plugins-dev)

=== platforms/linux/appdata/CMakeLists.txt ===
IF (UNIX)
# install appdata files
  INSTALL(FILES calibrate_lens_gui.appdata.xml hugin.appdata.xml PTBatcherGUI.appdata.xml DESTINATION ${DATADIR}/appdata)
ENDIF (UNIX)

=== src/hugin1/stitch_project/CMakeLists.txt ===

set( PROGNAME hugin_stitch_project )
IF (WIN32)
  add_executable(${PROGNAME} WIN32 hugin_stitch_project.cpp hugin_stitch_project_rc.rc)
ELSEIF(APPLE)
  set( PROGNAME HuginStitchProject )
  set( MACOSX_BUNDLE_ICON_FILE Hugin.icns )

  set( INFO_PLIST ${CMAKE_MODULE_PATH}/HuginBundleInfo.plist.in)
  # disabled because stitch_project can't handle MacOpenFiles correctly
  # set( INFO_PLIST ${CMAKE_MODULE_PATH}/HuginBundleInfoPTO.plist.in)
  # set( MACOSX_BUNDLE_TYPE_ROLE Viewer )
  
  set( MACOSX_BUNDLE_VERSION ${V_MAJOR}.${V_MINOR}.${V_PATCH} )
  set( MACOSX_BUNDLE_SHORT_VERSION_STRING ${MACOSX_BUNDLE_VERSION})
  set( MACOSX_BUNDLE_LONG_VERSION_STRING "Version ${MACOSX_BUNDLE_VERSION}" )
  set( MACOSX_BUNDLE_GUI_IDENTIFIER net.sourceforge.HuginStitchProject)
  set( MACOSX_BUNDLE_INFO_STRING "HuginStitchProject ${MACOSX_BUNDLE_VERSION}" )
  set( MACOSX_BUNDLE_BUNDLE_NAME "HuginStitchProject" )
  set( MACOSX_BUNDLE_COPYRIGHT "Copyright 2007 Pablo d'Angelo" )

  IF(MAC_SELF_CONTAINED_BUNDLE)

    # Tools
    set( TOOLS ${CMAKE_BINARY_DIR}/src/tools/align_image_stack ${CMAKE_BINARY_DIR}/src/tools/nona
               ${CMAKE_BINARY_DIR}/src/tools/hugin_hdrmerge ${CMAKE_BINARY_DIR}/src/tools/verdandi
               ${CMAKE_SOURCE_DIR}/mac/ExternalPrograms/repository/bin/enblend
               ${CMAKE_SOURCE_DIR}/mac/ExternalPrograms/repository/bin/enfuse 
    )

    FOREACH(_file ${TOOLS})
      SET_SOURCE_FILES_PROPERTIES( ${_file} PROPERTIES 
           MACOSX_PACKAGE_LOCATION "MacOS" 
           GENERATED TRUE)
    ENDFOREACH(_file)


    #other files
    FILE(GLOB OTHER ${CMAKE_SOURCE_DIR}/src/hugin1/executor/*.executor)
    LIST(APPEND OTHER ${CMAKE_SOURCE_DIR}/src/hugin1/base_wx/hugin_exiftool_copy.arg)
    FOREACH(_file ${OTHER})
      SET_SOURCE_FILES_PROPERTIES( ${_file} PROPERTIES 
           MACOSX_PACKAGE_LOCATION "Resources/xrc" )
    ENDFOREACH(_file)

    #translations
    FILE(GLOB PO_FILES "${CMAKE_SOURCE_DIR}/src/translations/*.po")
    SET(TRANSLATION_FILES )
    FOREACH(_file_po ${PO_FILES})
      GET_FILENAME_COMPONENT(LANG ${_file_po} NAME_WE)
      SET(_file_out ${CMAKE_BINARY_DIR}/src/translations/mac/${LANG}.lproj/hugin.mo)
      LIST(APPEND TRANSLATION_FILES ${_file_out} )
      SET_SOURCE_FILES_PROPERTIES( ${_file_out} PROPERTIES 
              MACOSX_PACKAGE_LOCATION "Resources/${LANG}.lproj" 
              GENERATED TRUE)
    ENDFOREACH(_file_po)

    SET(EN_US_HACK "${CMAKE_BINARY_DIR}/src/translations/mac/en_US.lproj")
    LIST(APPEND TRANSLATION_FILES ${EN_US_HACK})
    SET_SOURCE_FILES_PROPERTIES( ${EN_US_HACK} PROPERTIES 
              MACOSX_PACKAGE_LOCATION "Resources" 
              GENERATED TRUE)

    # Icons
    set( ICON_FILES "../hugin/${MACOSX_BUNDLE_ICON_FILE}" "../hugin/${MACOSX_BUNDLE_TYPE_ICON_FILE}" )
    FOREACH(_file ${ICON_FILES})
      SET_SOURCE_FILES_PROPERTIES( ${_file} PROPERTIES 
           MACOSX_PACKAGE_LOCATION 
           "Resources" )
    ENDFOREACH(_file)


    ADD_EXECUTABLE( ${PROGNAME} MACOSX_BUNDLE hugin_stitch_project.cpp 
          ${ICON_FILES} ${TRANSLATION_FILES} ${TOOLS} ${OTHER})
    if(INFO_PLIST)
      set_target_properties(${PROGNAME} PROPERTIES
            MACOSX_BUNDLE_INFO_PLIST ${INFO_PLIST})
    endif(INFO_PLIST)

    ADD_DEPENDENCIES(${PROGNAME} align_image_stack nona hugin_hdrmerge verdandi
      translations)

  ELSE (MAC_SELF_CONTAINED_BUNDLE)

    set( ICON_FILES ${MACOSX_BUNDLE_ICON_FILE} ${MACOSX_BUNDLE_TYPE_ICON_FILE} )
    ADD_EXECUTABLE( ${PROGNAME} MACOSX_BUNDLE hugin_stitch_project.cpp 
                    ${ICON_FILES})

  ENDIF(MAC_SELF_CONTAINED_BUNDLE)
     

ELSE (WIN32)
 add_executable(${PROGNAME} hugin_stitch_project.cpp)
ENDIF (WIN32)


target_link_libraries(${PROGNAME} huginbasewx ${common_libs} ${image_libs} ${wxWidgets_LIBRARIES})

IF (APPLE)
  IF (NOT MAC_SELF_CONTAINED_BUNDLE)
    install(TARGETS ${PROGNAME}
            DESTINATION ${INSTALL_OSX_BUNDLE_DIR})
  ELSE (NOT MAC_SELF_CONTAINED_BUNDLE)
    install(TARGETS ${PROGNAME}
            DESTINATION "Hugin"
            COMPONENT ${PROGNAME})
  ENDIF (NOT MAC_SELF_CONTAINED_BUNDLE)
ELSE(APPLE)
  install(TARGETS ${PROGNAME}
          DESTINATION ${BINDIR})
ENDIF(APPLE)

=== src/hugin_cpfind/localfeatures/CMakeLists.txt ===
# the liblocalfeature library
set (LF_SRC  RansacFiltering.cpp Homography.cpp Image.cpp
             CircularKeyPointDescriptor.cpp
	      KeyPointDetector.cpp KeyPointIO.cpp MathStuff.cpp)

set (LF_HEADER BoundedSet.h BoxFilter.h CircularKeyPointDescriptor.h
               Homography.h Image.h KeyPoint.h KeyPointDescriptor.h
               KeyPointDetector.h KeyPointIO.h MathStuff.h
               PointMatch.h RansacFiltering.h Sieve.h WaveFilter.h )

IF (${HUGIN_SHARED_LIBS})
    add_library(localfeatures SHARED ${LF_SRC} ${LF_HEADER})
    set_target_properties(localfeatures PROPERTIES VERSION ${HUGIN_LIB_VERSION})
    IF(WIN32)
      install(TARGETS localfeatures RUNTIME DESTINATION ${BINDIR})
    ELSEIF(${HUGIN_LIBS_PRIVATE_DIR})
      install(TARGETS localfeatures LIBRARY DESTINATION ${LIBDIR}/hugin NAMELINK_SKIP)
    ELSE(WIN32)
      install(TARGETS localfeatures LIBRARY DESTINATION ${LIBDIR} NAMELINK_SKIP)
    ENDIF(WIN32)
ELSE (${HUGIN_SHARED_LIBS})
    add_library(localfeatures STATIC ${LF_SRC} ${LF_HEADER})
ENDIF (${HUGIN_SHARED_LIBS})

=== debian/changelog ===
hugin (2018.0.0+dfsg-3) unstable; urgency=medium

  * 20_flann_find_pkg-config.patch: Use pkg-config to find flann, linking
    hugin against liblz4 which is needed now, since flann dropped the included
    copy of liblz4.
  * [lintian] Delete empty line at bottom of changelog.
  * 30_typo_constrast.diff: Fix typo in manpage found by lintian.

 -- Andreas Metzler <ametzler@debian.org>  Tue, 16 Oct 2018 18:35:04 +0200

hugin (2018.0.0+dfsg-2) unstable; urgency=low

  * Drop get-orig-source target and add Files-Excluded stanza to
    debian/copyright, delegating the heavy lifting to uscan.
  * Delete superfluous --parallel argument to dh.
  * Fix a couple of syntax errors in debian/copyright.
  * Point vcs* to salsa.
  * Set Rules-Requires-Root: no.
  * Point $HOME and $XDG_RUNTIME_DIR to temporary dir in autopkgtest.
    Closes: #903268
  * Fix space-in-std-shortname-in-dep5-copyright lintian warning.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 11 Aug 2018 15:09:50 +0200

hugin (2018.0.0+dfsg-1) unstable; urgency=low

  * New upstream version, identical to rc2.
  * Upload to unstable.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 03 Feb 2018 14:27:24 +0100

hugin (2018.0.0~rc2+dfsg-1) experimental; urgency=medium

  * New upstream version.

 -- Andreas Metzler <ametzler@debian.org>  Thu, 01 Feb 2018 18:48:05 +0100

hugin (2018.0.0~rc1+dfsg-1) experimental; urgency=low

  * New upstream version.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 20 Jan 2018 18:38:31 +0100

hugin (2018.0.0~beta1+dfsg-1) experimental; urgency=low

  * New upstream version.
  * Refresh 43_fallbackhelp.patch.
  * [lintian] Delete trailing whitespace in changelog.
  * [lintian] Use /usr/share/dpkg/pkg-info.mk instead of parsing changelog.
  * Drop override_dh_auto_build, upstream already (re)generates the manpages
    at build time.
  * Ship newly available hugin_stacker.
  * Use debhelper v10 compat.
  * Enable dh_missing.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 09 Dec 2017 18:29:16 +0100

=== debian/control ===
Source: hugin
Section: graphics
Priority: optional
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Andreas Metzler <ametzler@debian.org>
# hugin can use Boost::Signal or in Boost >= 1.54 Boost::Signal2 which is
# shipped in libboost-dev.
Build-Depends: debhelper (>= 10), dh-python, cmake (>= 3.1),
 libboost-graph-dev (>= 1.47), libboost-thread-dev (>= 1.47),
 libboost-regex-dev (>= 1.47), libboost-filesystem-dev (>= 1.47),
 libboost-iostreams-dev (>= 1.47), libboost-system-dev (>= 1.47),
 libboost-signals-dev (>= 1.47) | libboost-dev (>= 1.54),
 liblcms2-dev,
 zlib1g-dev, libexiv2-dev (>= 0.12), libjpeg-dev,
 libopenexr-dev, libpano13-dev (>= 2.9.19~beta1), libpng-dev,
 libtiff-dev, libgtk2.0-dev, libwxgtk3.0-dev, libglew-dev,
 swig (>= 2.0), python-dev, libsqlite3-dev,
 libflann-dev, libfftw3-dev,
 libvigraimpex-dev (>=1.9)
Build-Conflicts: wx2.6-headers, wx2.8-headers
Standards-Version: 4.2.0
Rules-Requires-Root: no
Homepage: http://hugin.sourceforge.net/
Vcs-Git: https://salsa.debian.org/debian-phototools-team/hugin.git
Vcs-Browser: https://salsa.debian.org/debian-phototools-team/hugin

Package: hugin
Architecture: any
Depends: hugin-tools (= ${binary:Version}), enblend (>= 3.2), enfuse, libimage-exiftool-perl, make, ${shlibs:Depends}, ${misc:Depends}
Breaks: hugin-bin (<< 0.7.0~svn)
Replaces: hugin-bin (<< 0.7.0~svn), hugin-data (<< 0.7.0~svn), hugin-tools (<< 0.7.0~svn)
Description: panorama photo stitcher - GUI tools
 Hugin is a panorama photo stitching program. Essentially, Hugin is a
 GUI frontend for Panorama Tools. Stitching is accomplished by using
 several overlapping photos taken from the same location, and using
 control points to align and transform the photos so that they can be
 blended together to form a larger image. Hugin allows for the easy
 creation of control points between two images, optimization of the
 image transforms, and much more.
 .
 This package includes the following graphical interfaces, using the
 command-line tools provided in the hugin-tools package:
  * hugin                - Hugin panorama creator.
  * hugin_stitch_project - Hugin batch stitcher.
  * PTBatcherGUI         - Batch controller for the stitching process.
  * calibrate_lens_gui   - Lens calibration tool.

Package: hugin-tools
Architecture: any
Depends: hugin-data (= ${source:Version}), ${shlibs:Depends}, ${misc:Depends},
  ${python:Depends}
Breaks: hugin-bin (<< 0.7.0~svn), ${python:Breaks}
Replaces: hugin-bin (<< 0.7.0~svn)
Recommends: libpano13-bin
Provides: python-hsi
Description: panorama photo stitcher - commandline tools
 Hugin is a panorama photo stitching program.
 .
 This package includes command-line tools used by hugin and other
 packages for image stitching and High Dynamic Range (HDR) images:
  * align_image_stack  - Align overlapping images for HDR creation.
  * autooptimiser      - Optimize image positions.
  * celeste_standalone - Remove cloud-like control points.
  * cpclean            - Remove wrong control points.
  * cpfind             - Patent-free control-point detector
  * deghosting_mask    - Creates mask for removing ghosting in images.
  * fulla              - Correct lens distortion, vignetting, and
                         chromatic aberration.
  * geocpset           - Set geometric control points.
  * hugin_executor     - CLI stitching tool.
  * hugin_hdrmerge     - Merge overlapping images.
  * hugin_lensdb       - Hugin lens database maintenance.
  * icpfind            - Control-point detector wrapper program.
  * linefind           - Detect vertical features in images.
  * nona               - Remap images. (Also does simple stitching.)
  * pano_modify        - Change output parameters of project file.
  * pto_gen            - Generate a Hugin project file from a list of images.
  * pto_lensstack      - Modify assigned lenses and stack in pto files.
  * pto_mask           - Apply a mask.
  * pto_merge          - Merges two or more Hugin project files.
  * pto_move           - Move a project file with all images in it.
  * pto_template       - Apply a template file.
  * pto_var            - Change image variables inside Hugin .pto project
                         files
  * tca_correct        - Calculate transverse chromatic aberration.
  * verdandi           - Blend images using watershed algorithm.
  * vig_optimize       - Determine the radial vignetting.

Package: hugin-data
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
Breaks: ${python:Breaks}
# imports of included plugins
Suggests: python-wxgtk3.0
Description: panorama photo stitcher - common data files
 Hugin is a panorama photo stitching program.
 .
 This package includes the data files needed by the hugin and
 hugin-tools packages.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed -Wl,-z,defs
export DEB_CFLAGS_MAINT_APPEND := -Wall
export DEB_CXXFLAGS_MAINT_APPEND := -Wall
export DEB_BUILD_MAINT_OPTIONS := hardening=+all
# Default python version.
PYTHONDEFVERSION := $(shell pyversions -d | sed -e 's/python\([0-9.]\+\)/\1/')

include /usr/share/dpkg/pkg-info.mk

# Upstream version can be overriden so as to fetch newer revisions
# without having to modify the top-most changelog entry
UVERSION ?= $(subst +dfsg,,$(DEB_VERSION_UPSTREAM))

override_dh_makeshlibs:
	dh_makeshlibs --noscripts

override_dh_auto_install:
	dh_auto_install --verbose
	rm -vf debian/tmp/usr/share/hugin/xrc/data/help_en_EN/LICENCE.manual

override_dh_auto_clean:
	dh_auto_clean --verbose
	rm -vf src/celeste/Config.h

override_dh_auto_configure:
	dh_auto_configure --verbose --\
		-DBUILD_HSI:BOOL=ON \
		-DPythonLibs_FIND_VERSION=$(PYTHONDEFVERSION)

override_dh_python2:
	dh_python2 -i /usr/share/hugin/data/plugins
	dh_python2 -a --no-guessing-versions

%:
	dh $@ --with python2

override_dh_missing:
	dh_missing --list-missing

=== debian/watch ===
version=4

opts="uversionmangle=s/[_-]/\~/g,dversionmangle=s/\+dfsg//,compression=xz,repacksuffix=+dfsg" \
       http://sf.net/hugin/hugin-(.+)@ARCHIVE_EXT@
